diff -urNEBb gcc-2.95.3-orig/gcc/config/m68k/xm-amigaos.h gcc-2.95.3/gcc/config/m68k/xm-amigaos.h
--- gcc-2.95.3-orig/gcc/config/m68k/xm-amigaos.h	1970-01-01 01:00:00.000000000 +0100
+++ gcc-2.95.3/gcc/config/m68k/xm-amigaos.h	2003-12-02 17:50:55.000000000 +0100
@@ -0,0 +1,105 @@
+/* Configuration for GNU C-compiler for m68k Amiga, running AmigaOS.
+   Copyright (C) 1992, 93-96, 1997 Free Software Foundation, Inc.
+   Contributed by Markus M. Wild (wild@amiga.physik.unizh.ch).
+
+This file is part of GNU CC.
+
+GNU CC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU CC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU CC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+/* First include the generic header, then modify some parts.  */
+
+#include "m68k/xm-m68k.h"
+
+#ifndef _FCNTL_H_
+#include <fcntl.h>
+#endif
+
+/* Define various things that the AmigaOS host has.  */
+
+#define HAVE_ATEXIT
+#define HAVE_RENAME
+
+/* AmigaOS specific headers, such as from the Native Developer Update kits,
+   go in SYSTEM_INCLUDE_DIR.  STANDARD_INCLUDE_DIR is the equivalent of
+   Unix "/usr/include".  All other include paths are set in Makefile.  */
+
+#define SYSTEM_INCLUDE_DIR	"/gcc/os-include"
+#define STANDARD_INCLUDE_DIR	"/gcc/include"
+
+#define STANDARD_EXEC_PREFIX_1 "/gcc/lib/gcc/"
+#define STANDARD_STARTFILE_PREFIX_1 "/gcc/lib/"
+#define STANDARD_STARTFILE_PREFIX_2 "/gcc/lib/"
+
+/* The AmigaOS stores file names with regard to upper/lower case, but actions
+   on existing files are case independent on the standard filesystems.
+
+   A good example of where this causes problems is the conflict between the C
+   include file <string.h> and the C++ include file <String.h>, where the C++
+   include file dir is searched first and thus causes includes of <string.h>
+   to include <String.h> instead.
+
+   In order to solve this problem we define the macro OPEN_CASE_SENSITIVE as
+   the name of the function that takes the same args as open() and does case
+   dependent opens.  */
+
+#define OPEN_CASE_SENSITIVE(NAME, FLAGS, MODE) open ((NAME), (FLAGS) | O_CASE, (MODE))
+
+/* On the AmigaOS, there are two pathname separators, '/' (DIR_SEPARATOR)
+   and ':' (VOL_SEPARATOR).  DIR_SEPARATOR defaults to the correct
+   character, so we don't have to explicitly set it.  */
+
+#define DIR_SEPARATOR '/'
+#define VOL_SEPARATOR ':'
+
+/* Do *not* use this define, otherwise Amiga-devicenames ('DEV:') won't 
+   work:  */
+// #define DIR_SEPARATOR_2 VOL_SEPARATOR
+
+
+/* Determine whether a '\0'-terminated file name is absolute or not.
+
+   This checks for both, '/' as the first character, since we're running under
+   ixemul.library which provides for this unix'ism, and for the usual 
+   logical-terminator, ':', somewhere in the filename.  */
+
+#define FILE_NAME_ABSOLUTE_P(NAME) ((NAME)[0] == '/' || index ((NAME), ':'))
+
+/* Like the above, but the file name is not '\0'-terminated.  */
+
+#define FILE_NAME_ABSOLUTE_N_P(NAME, LEN) amigaos_file_name_absolute_n ((NAME), (LEN))
+
+/* Return the file name part of the path name.  */
+
+#define FILE_NAME_NONDIRECTORY(NAME)					\
+  (rindex ((NAME), '/') ? rindex ((NAME), '/') + 1			\
+			: (rindex ((NAME), ':') ? rindex ((NAME), ':') + 1 \
+						: (NAME)))
+
+/* Generate the name of the cross reference file.  */
+
+#define XREF_FILE_NAME(BUFF, NAME)					\
+do									\
+  {									\
+    char *filesrc, *filedst;						\
+    strcpy ((BUFF), (NAME));						\
+    filesrc = FILE_NAME_NONDIRECTORY (NAME);				\
+    filedst = (BUFF) + (filesrc - (NAME));				\
+    sprintf (filedst, ".%s.gxref", filesrc);				\
+  }									\
+while (0)
+
+/* olsen: we don't want to link with libgcc by default */
+#define LIBGCC_SPEC ""
diff -urNEBb gcc-2.95.3-orig/gcc/config/rs6000/amigaos.c gcc-2.95.3/gcc/config/rs6000/amigaos.c
--- gcc-2.95.3-orig/gcc/config/rs6000/amigaos.c	1970-01-01 01:00:00.000000000 +0100
+++ gcc-2.95.3/gcc/config/rs6000/amigaos.c	2003-12-02 17:50:55.000000000 +0100
@@ -0,0 +1,269 @@
+/* Subroutines used for code generation on Amiga OS 4
+   Copyright (C) 1991, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001
+   Free Software Foundation, Inc.
+   Contributed by Thomas Frieden (ThomasF@hyperion-entertainment.com)
+
+This file is part of GNU CC.
+
+GNU CC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU CC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU CC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+#include "config.h"
+#include "system.h"
+#include "rtl.h"
+#include "regs.h"
+#include "hard-reg-set.h"
+#include "real.h"
+#include "insn-config.h"
+#include "conditions.h"
+#include "insn-flags.h"
+#include "insn-attr.h"
+#include "flags.h"
+#include "recog.h"
+#include "expr.h"
+#include "obstack.h"
+#include "tree.h"
+#include "except.h"
+#include "function.h"
+#include "output.h"
+#include "toplev.h"
+
+#undef DEBUG
+#ifdef DEBUG
+#define dprintf(FORMAT, ARG...)      		\
+printf("%s: ", __PRETTY_FUNCTION__);		\
+printf(FORMAT , ## ARG)
+#else
+#define dprintf(FORMAT, ARG...)
+#endif
+
+
+void
+amigaos_init_cumulative_args (cum, fntype, libname, incoming)
+     CUMULATIVE_ARGS *cum;
+     tree fntype;
+     rtx libname ATTRIBUTE_UNUSED;
+     int incoming;
+{
+    dprintf("enter\n");
+    init_cumulative_args(cum, fntype, libname, incoming);
+
+    /* Check if either libcall or linear varargs, set appropriate cookie */
+    if (fntype && (lookup_attribute("libcall", TYPE_ATTRIBUTES (fntype))))
+		cum->call_cookie |= CALL_LINEARVARARGS;
+
+    if (fntype && (lookup_attribute("linearvarargs", TYPE_ATTRIBUTES (fntype))))
+		cum->call_cookie |= CALL_LINEARVARARGS;
+
+    dprintf("exit\n");
+}
+
+
+void
+amigaos_function_arg_advance (cum, mode, type, named)
+     CUMULATIVE_ARGS *cum;
+     enum machine_mode mode;
+     tree type;
+     int named;
+{
+    dprintf("enter\n");
+    function_arg_advance(cum, mode, type, named);
+ 
+    if (cum->call_cookie & CALL_LINEARVARARGS && cum->sysv_gregno + cum->fregno - GP_ARG_MIN_REG - FP_ARG_MIN_REG > cum->orig_nargs)
+    {
+	cum->sysv_gregno = GP_ARG_MAX_REG + 1;
+	cum->fregno = FP_ARG_V4_MAX_REG + 1;
+    }
+    dprintf("exit\n");
+}
+
+
+struct rtx_def *
+amigaos_function_arg (cum, mode, type, named)
+     CUMULATIVE_ARGS *cum;
+     enum machine_mode mode;
+     tree type;
+     int named;
+{
+    struct rtx_def *res = 0;
+
+    dprintf("enter\n");
+    if (mode == VOIDmode && cum->call_cookie & CALL_LINEARVARARGS)
+	res = GEN_INT (cum->call_cookie);
+    else
+	res =  function_arg (cum, mode, type, named);
+
+    dprintf("exit\n");
+
+    return res;
+}
+
+
+
+void
+amigaos_setup_incoming_varargs (cum, mode, type, pretend_size, no_rtl)
+     CUMULATIVE_ARGS *cum;
+     enum machine_mode mode;
+     tree type;
+     int *pretend_size;
+     int no_rtl;
+
+{
+  CUMULATIVE_ARGS next_cum;
+  int reg_size = TARGET_32BIT ? 4 : 8;
+  rtx save_area;
+  int first_reg_offset;
+
+  dprintf("enter\n");
+  if (cum->call_cookie & CALL_LINEARVARARGS)
+  {
+      tree fntype;
+      int stdarg_p;
+      
+      fntype = TREE_TYPE (current_function_decl);
+      stdarg_p = (TYPE_ARG_TYPES (fntype) != 0
+		  && (TREE_VALUE (tree_last (TYPE_ARG_TYPES (fntype)))
+		      != void_type_node));
+      
+      /* For varargs, we do not want to skip the dummy va_dcl argument.
+	 For stdargs, we do want to skip the last named argument.  */
+      next_cum = *cum;
+      if (stdarg_p)
+	  function_arg_advance (&next_cum, mode, type, 1);
+      
+      /* Indicate to allocate space on the stack for varargs save area.  */
+      /* ??? Does this really have to be located at a magic spot on the
+	 stack, or can we allocate this with assign_stack_local instead.  */
+      rs6000_sysv_varargs_p = 1;
+      if (! no_rtl)
+	  save_area = plus_constant (virtual_stack_vars_rtx,
+				     - RS6000_VARARGS_SIZE);
+
+      first_reg_offset = next_cum.sysv_gregno - GP_ARG_MIN_REG;
+
+  }
+  else
+  {
+      setup_incoming_varargs(cum, mode, type, pretend_size, no_rtl);
+  }
+
+  dprintf("exit\n");
+
+}
+
+
+struct rtx_def *
+amigaos_expand_builtin_saveregs (args)
+     tree args ATTRIBUTE_UNUSED;
+{
+  rtx block, mem_gpr_fpr, mem_reg_save_area, mem_overflow, tmp;
+  tree fntype;
+  int stdarg_p;
+  HOST_WIDE_INT words, gpr, fpr;
+  struct rtx_def *res;
+
+  dprintf("enter\n");
+
+  if (current_function_args_info.call_cookie & CALL_LINEARVARARGS)
+  {
+      HOST_WIDE_INT bits;
+
+      fntype = TREE_TYPE (current_function_decl);
+      stdarg_p = (TYPE_ARG_TYPES (fntype) != 0
+		  && (TREE_VALUE (tree_last (TYPE_ARG_TYPES (fntype)))
+		      != void_type_node));
+      
+      /* Allocate the va_list constructor.  */
+      block = assign_stack_local (BLKmode, 3 * UNITS_PER_WORD, BITS_PER_WORD);
+      RTX_UNCHANGING_P (block) = 1;
+      RTX_UNCHANGING_P (XEXP (block, 0)) = 1;
+      
+      mem_gpr_fpr = change_address (block, word_mode, XEXP (block, 0));
+      mem_overflow = change_address (block, ptr_mode,
+				     plus_constant (XEXP (block, 0),
+                                                UNITS_PER_WORD));
+      /*mem_reg_save_area = change_address (block, ptr_mode,
+	plus_constant (XEXP (block, 0),
+	2 * UNITS_PER_WORD));*/
+      
+      /* Construct the two characters of `gpr' and `fpr' as a unit.  */
+      words = current_function_args_info.words;
+      gpr = current_function_args_info.sysv_gregno - GP_ARG_MIN_REG;
+      
+      /* Varargs has the va_dcl argument, but we don't count it.  */
+      if (!stdarg_p)
+      {
+	  if (gpr > GP_ARG_NUM_REG)
+	      words -= 1;
+      }
+      
+      bits = (GP_ARG_MAX_REG - GP_ARG_MIN_REG + 1) << 8
+	  | (FP_ARG_MAX_REG - FP_ARG_MIN_REG + 1);
+      if (HOST_BITS_PER_WIDE_INT >= BITS_PER_WORD)
+	  tmp = GEN_INT (bits << (BITS_PER_WORD - 16));
+      else
+      {
+	  bits <<= BITS_PER_WORD - HOST_BITS_PER_WIDE_INT - 16;
+	  tmp = immed_double_const (0, bits, word_mode);
+      }
+      
+      emit_move_insn (mem_gpr_fpr, tmp);
+      
+      /* Find the overflow area.  */
+      tmp = expand_binop (Pmode, add_optab, virtual_incoming_args_rtx,
+			  GEN_INT (words * UNITS_PER_WORD),
+			  mem_overflow, 0, OPTAB_WIDEN);
+      if (tmp != mem_overflow)
+	  emit_move_insn (mem_overflow, tmp);
+      
+      /*tmp = expand_binop (Pmode, add_optab, virtual_stack_vars_rtx,
+	GEN_INT (-RS6000_VARARGS_SIZE),
+	mem_reg_save_area, 0, OPTAB_WIDEN);
+	if (tmp != mem_reg_save_area)
+	emit_move_insn (mem_reg_save_area, tmp);*/
+      
+      /* Return the address of the va_list constructor.  */
+      res = XEXP (block, 0);
+  }
+  else
+  {
+      res = expand_builtin_saveregs(args);
+  }
+
+  dprintf("exit\n");
+  return res;
+}
+
+
+int amigaos_valid_type_attribute_p (type, attributes, identifier, args)
+     tree type;
+     tree attributes ATTRIBUTE_UNUSED;
+     tree identifier;
+     tree args;
+{
+
+    if (TREE_CODE (type) != FUNCTION_TYPE
+	&& TREE_CODE (type) != FIELD_DECL
+	&& TREE_CODE (type) != TYPE_DECL)
+	return 0;
+
+    if (is_attribute_p ("libcall", identifier))
+	return (args == NULL_TREE);
+    
+    if (is_attribute_p ("linearvarargs", identifier))
+	return (args == NULL_TREE);
+
+    return rs6000_valid_type_attribute_p(type, attributes, identifier, args);
+}
diff -urNEBb gcc-2.95.3-orig/gcc/config/rs6000/amigaos.h gcc-2.95.3/gcc/config/rs6000/amigaos.h
--- gcc-2.95.3-orig/gcc/config/rs6000/amigaos.h	1970-01-01 01:00:00.000000000 +0100
+++ gcc-2.95.3/gcc/config/rs6000/amigaos.h	2003-12-31 17:12:22.000000000 +0100
@@ -0,0 +1,134 @@
+/* Definitions of target machine for GNU compiler, for AmigaOS.
+   Copyright (C) 1997 Free Software Foundation, Inc.
+
+
+This file is part of GNU CC.
+
+GNU CC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU CC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU CC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+
+#include "rs6000/sysv4.h"
+
+/* Don't assume anything about the header files. */
+#define NO_IMPLICIT_EXTERN_C
+
+#undef MD_EXEC_PREFIX
+#undef MD_STARTFILE_PREFIX
+
+/* Make CPU default to 604e. FIXME: Make this 750 later */
+#undef PROCESSOR_DEFAULT
+#define PROCESSOR_DEFAULT PROCESSOR_PPC604e
+
+#undef DEFAULT_ABI
+#define DEFAULT_ABI ABI_V4
+
+/* Make most of the definitions from other compilers available */
+#undef CPP_PREDEFINES
+#define CPP_PREDEFINES \
+ "-DPPC -D__ELF__ -Dpowerpc -Acpu(powerpc) -Amachine(powerpc) " \
+ "-DAMIGA -DAMIGAOS -DAMIGAOS4 -D__amigaos__ -D__amiga__ -D__amigaos4__ " \
+ "-Damiga -Damigaos -Damigaos4" 
+
+
+#ifdef __amigaos4__
+#undef CPP_OS_DEFAULT_SPEC
+#define CPP_OS_DEFAULT_SPEC "-I/gcc/local/include -I/gcc/os-include"
+#else
+#undef CPP_OS_DEFAULT_SPEC
+#define CPP_OS_DEFAULT_SPEC "-I/usr/local/amiga/ppc-amigaos/local/include -I/usr/local/amiga/ppc-amigaos/local/os-include"
+#endif
+
+#ifdef __amigaos4__
+#undef	LINK_OS_DEFAULT_SPEC
+#define	LINK_OS_DEFAULT_SPEC "-L/gcc/local/lib"
+#else
+#undef	LINK_OS_DEFAULT_SPEC
+#define	LINK_OS_DEFAULT_SPEC "-L/usr/local/amiga/ppc-amigaos/local/lib"
+#endif
+
+#undef LINK_SPEC
+#define LINK_SPEC "\
+--defsym __amigaos4__=1 \
+-q -n -d %{h*} %{v:-V} %{G*} \
+%{Wl,*:%*} %{YP,*} %{R*} \
+%{Qy:} %{!Qn:-Qy} \
+%(link_target) \
+%(link_os)"
+
+#undef STARTFILE_SPEC
+#define STARTFILE_SPEC 	"crtbegin.o%s %{pg:gcrt0.o%s} %{!pg:crt0.o%s} mainnb.o%s"
+
+#undef ENDFILE_SPEC
+#define ENDFILE_SPEC "crtend.o%s"
+
+#undef LIB_SPEC
+#define LIB_SPEC								\
+"%{!unix: --start-group -lc -lamiga --end-group } "				\
+"%{unix: --start-group -lunix -lc -lamiga -lunix --end-group } "		\
+"%{auto: -lauto} " \
+"%{profile:-lc_p}%{!profile:-lc} "
+
+#undef TARGET_VERSION
+#define TARGET_VERSION fprintf (stderr, " (PowerPC AmigaOS 4)");
+
+
+#undef DEFAULT_VTABLE_THUNKS
+#ifndef USE_GNULIBC_1
+#define DEFAULT_VTABLE_THUNKS 1
+#endif
+
+#undef JUMP_TABLES_IN_TEXT_SECTION
+#define JUMP_TABLES_IN_TEXT_SECTION 0
+
+/* Used as cookie for linear vararg passing */
+#define CALL_LINEARVARARGS      0x10000000
+
+/* Prototypes */
+void amigaos_init_cumulative_args();
+void amigaos_function_arg_advance();
+struct rtx_def *amigaos_function_arg();
+void amigaos_setup_incoming_varargs();
+struct rtx_def *amigaos_expand_builtin_saveregs();
+int amigaos_valid_type_attribute_p();
+
+/* Overrides */
+#undef INIT_CUMULATIVE_ARGS
+#define INIT_CUMULATIVE_ARGS(CUM, FNTYPE, LIBNAME, INDIRECT) \
+    amigaos_init_cumulative_args(&CUM, FNTYPE, LIBNAME, FALSE)
+
+#undef INIT_CUMULATIVE_INCOMING_ARGS
+#define INIT_CUMULATIVE_INCOMING_ARGS(CUM, FNTYPE, LIBNAME) \
+    amigaos_init_cumulative_args(&CUM, FNTYPE, LIBNAME, TRUE)
+
+#undef FUNCTION_ARG_ADVANCE
+#define FUNCTION_ARG_ADVANCE(CUM, MODE, TYPE, NAMED)    \
+    amigaos_function_arg_advance(&CUM, MODE, TYPE, NAMED)
+
+#undef FUNCTION_ARG
+#define FUNCTION_ARG(CUM, MODE, TYPE, NAMED) \
+    amigaos_function_arg(&CUM, MODE, TYPE, NAMED)
+
+#undef SETUP_INCOMING_VARARGS
+#define SETUP_INCOMING_VARARGS(CUM,MODE, TYPE,PRETEND_SIZE, NO_RTL) \
+    amigaos_setup_incoming_varargs(&CUM, MODE, TYPE, &PRETEND_SIZE, NO_RTL)
+
+#undef EXPAND_BUILTIN_SAVEREGS
+#define EXPAND_BUILTIN_SAVEREGS(ARGS) \
+    amigaos_expand_builtin_saveregs(ARGS)
+
+#undef VALID_MACHINE_TYPE_ATTRIBUTE
+#define VALID_MACHINE_TYPE_ATTRIBUTE(TYPE, ATTRIBUTES, NAME, ARGS) \
+    amigaos_valid_type_attribute_p(TYPE, ATTRIBUTES, NAME, ARGS)
diff -urNEBb gcc-2.95.3-orig/gcc/config/rs6000/amigaos.h~ gcc-2.95.3/gcc/config/rs6000/amigaos.h~
--- gcc-2.95.3-orig/gcc/config/rs6000/amigaos.h~	1970-01-01 01:00:00.000000000 +0100
+++ gcc-2.95.3/gcc/config/rs6000/amigaos.h~	2003-12-06 18:31:20.000000000 +0100
@@ -0,0 +1,123 @@
+/* Definitions of target machine for GNU compiler, for AmigaOS.
+   Copyright (C) 1997 Free Software Foundation, Inc.
+
+
+This file is part of GNU CC.
+
+GNU CC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU CC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU CC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+
+#include "rs6000/sysv4.h"
+
+/* Don't assume anything about the header files. */
+#define NO_IMPLICIT_EXTERN_C
+
+#undef MD_EXEC_PREFIX
+#undef MD_STARTFILE_PREFIX
+
+/* Make CPU default to 604e. FIXME: Make this 750 later */
+#undef PROCESSOR_DEFAULT
+#define PROCESSOR_DEFAULT PROCESSOR_PPC604e
+
+#undef DEFAULT_ABI
+#define DEFAULT_ABI ABI_V4
+
+/* Make most of the definitions from other compilers available */
+#undef CPP_PREDEFINES
+#define CPP_PREDEFINES \
+ "-DPPC -D__ELF__ -Dpowerpc -Acpu(powerpc) -Amachine(powerpc) " \
+ "-DAMIGA -DAMIGAOS -DAMIGAOS4 -D__amigaos__ -D__amiga__ -D__amigaos4__ " \
+ "-Damiga -Damigaos -Damigaos4" 
+
+
+#undef CPP_OS_DEFAULT_SPEC
+#define CPP_OS_DEFAULT_SPEC "-I/gcc/local/include -I/gcc/os-include"
+
+#undef	LINK_OS_DEFAULT_SPEC
+#define	LINK_OS_DEFAULT_SPEC "-L/gcc/local/lib"
+
+#undef LINK_SPEC
+#define LINK_SPEC "\
+--defsym __amigaos4__=1 \
+-q -n -d %{h*} %{v:-V} %{G*} \
+%{Wl,*:%*} %{YP,*} %{R*} \
+%{Qy:} %{!Qn:-Qy} \
+%(link_target) \
+%(link_os)"
+
+#undef STARTFILE_SPEC
+#define STARTFILE_SPEC 	"crtbegin.o%s %{pg:gcrt0.o%s} %{!pg:crt0.o%s} mainnb.o%s"
+
+#undef ENDFILE_SPEC
+#define ENDFILE_SPEC "crtend.o%s"
+
+#undef LIB_SPEC
+#define LIB_SPEC								\
+"%{!unix: --start-group -lc -lamiga --end-group } "				\
+"%{unix: --start-group -lunix -lc -lamiga -lunix --end-group } "		\
+"%{profile:-lc_p}%{!profile:-lc} "
+
+#undef TARGET_VERSION
+#define TARGET_VERSION fprintf (stderr, " (PowerPC AmigaOS 4)");
+
+
+#undef DEFAULT_VTABLE_THUNKS
+#ifndef USE_GNULIBC_1
+#define DEFAULT_VTABLE_THUNKS 1
+#endif
+
+#undef JUMP_TABLES_IN_TEXT_SECTION
+#define JUMP_TABLES_IN_TEXT_SECTION 0
+
+/* Used as cookie for linear vararg passing */
+#define CALL_LINEARVARARGS      0x10000000
+
+/* Prototypes */
+void amigaos_init_cumulative_args();
+void amigaos_function_arg_advance();
+struct rtx_def *amigaos_function_arg();
+void amigaos_setup_incoming_varargs();
+struct rtx_def *amigaos_expand_builtin_saveregs();
+int amigaos_valid_type_attribute_p();
+
+/* Overrides */
+#undef INIT_CUMULATIVE_ARGS
+#define INIT_CUMULATIVE_ARGS(CUM, FNTYPE, LIBNAME, INDIRECT) \
+    amigaos_init_cumulative_args(&CUM, FNTYPE, LIBNAME, FALSE)
+
+#undef INIT_CUMULATIVE_INCOMING_ARGS
+#define INIT_CUMULATIVE_INCOMING_ARGS(CUM, FNTYPE, LIBNAME) \
+    amigaos_init_cumulative_args(&CUM, FNTYPE, LIBNAME, TRUE)
+
+#undef FUNCTION_ARG_ADVANCE
+#define FUNCTION_ARG_ADVANCE(CUM, MODE, TYPE, NAMED)    \
+    amigaos_function_arg_advance(&CUM, MODE, TYPE, NAMED)
+
+#undef FUNCTION_ARG
+#define FUNCTION_ARG(CUM, MODE, TYPE, NAMED) \
+    amigaos_function_arg(&CUM, MODE, TYPE, NAMED)
+
+#undef SETUP_INCOMING_VARARGS
+#define SETUP_INCOMING_VARARGS(CUM,MODE, TYPE,PRETEND_SIZE, NO_RTL) \
+    amigaos_setup_incoming_varargs(&CUM, MODE, TYPE, &PRETEND_SIZE, NO_RTL)
+
+#undef EXPAND_BUILTIN_SAVEREGS
+#define EXPAND_BUILTIN_SAVEREGS(ARGS) \
+    amigaos_expand_builtin_saveregs(ARGS)
+
+#undef VALID_MACHINE_TYPE_ATTRIBUTE
+#define VALID_MACHINE_TYPE_ATTRIBUTE(TYPE, ATTRIBUTES, NAME, ARGS) \
+    amigaos_valid_type_attribute_p(TYPE, ATTRIBUTES, NAME, ARGS)
diff -urNEBb gcc-2.95.3-orig/gcc/config/rs6000/sol2.h gcc-2.95.3/gcc/config/rs6000/sol2.h
--- gcc-2.95.3-orig/gcc/config/rs6000/sol2.h	1999-01-11 14:34:11.000000000 +0100
+++ gcc-2.95.3/gcc/config/rs6000/sol2.h	2003-12-06 18:30:48.000000000 +0100
@@ -60,7 +60,7 @@
 #define	CPP_OS_DEFAULT_SPEC "%(cpp_os_solaris)"
 
 #undef	LINK_OS_DEFAULT_SPEC
-#define	LINK_OS_DEFAULT_SPEC "%(link_os_solaris)"
+#define	LINK_OS_DEFAULT_SPEC "-L/gcc/local/lib"
 
 #undef	CPP_ENDIAN_LITTLE_SPEC
 #define	CPP_ENDIAN_LITTLE_SPEC CPP_ENDIAN_SOLARIS_SPEC
diff -urNEBb gcc-2.95.3-orig/gcc/config/rs6000/t-amigaos gcc-2.95.3/gcc/config/rs6000/t-amigaos
--- gcc-2.95.3-orig/gcc/config/rs6000/t-amigaos	1970-01-01 01:00:00.000000000 +0100
+++ gcc-2.95.3/gcc/config/rs6000/t-amigaos	2003-12-06 20:01:51.000000000 +0100
@@ -0,0 +1,27 @@
+# Do not build libgcc1.
+LIBGCC1 =
+CROSS_LIBGCC1 =
+
+# These are really part of libgcc1, but this will cause them to be
+# built correctly, so... [taken from t-sparclite]
+LIB2FUNCS_EXTRA = fp-bit.c dp-bit.c
+
+dp-bit.c: $(srcdir)/config/fp-bit.c
+	cat $(srcdir)/config/fp-bit.c > dp-bit.c
+
+fp-bit.c: $(srcdir)/config/fp-bit.c
+	echo '#define FLOAT' > fp-bit.c
+	cat $(srcdir)/config/fp-bit.c >> fp-bit.c
+
+amigaos.o: $(srcdir)/config/rs6000/amigaos.c
+	$(CC) -c $(ALL_CFLAGS) $(ALL_CPPFLAGS) $(INCLUDES) $<
+
+# Build the libraries for both hard and soft floating point
+
+MULTILIB_OPTIONS = msoft-float mcpu=common
+MULTILIB_DIRNAMES = soft-float common
+
+SYSTEM_HEADER_DIR=gcc:os-include
+
+# FIXME: do this
+USE_COLLECT2 =
diff -urNEBb gcc-2.95.3-orig/gcc/config/rs6000/xm-amigaos.h gcc-2.95.3/gcc/config/rs6000/xm-amigaos.h
--- gcc-2.95.3-orig/gcc/config/rs6000/xm-amigaos.h	1970-01-01 01:00:00.000000000 +0100
+++ gcc-2.95.3/gcc/config/rs6000/xm-amigaos.h	2003-12-04 13:58:52.000000000 +0100
@@ -0,0 +1,31 @@
+/* Configuration for GNU C-compiler for AmigaOS host.
+   Copyright (C) 1997 Free Software Foundation, Inc.
+
+This file is part of GNU CC.
+
+GNU CC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU CC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU CC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+#include "rs6000/xm-sysv4.h"
+
+#define STANDARD_INCLUDE_DIR "/gcc/include"
+#define SYSTEM_INCLUDE_DIR "/gcc/os-include"
+
+#define DIR_SEPERATOR '/'
+
+#define PATH_SEPERATOR ';'
+
+#undef HAVE_GETWD
+#undef HAVE_SYS_WAIT_H
diff -urNEBb gcc-2.95.3-orig/gcc/config/rs6000/xm-macosx.h gcc-2.95.3/gcc/config/rs6000/xm-macosx.h
--- gcc-2.95.3-orig/gcc/config/rs6000/xm-macosx.h	1970-01-01 01:00:00.000000000 +0100
+++ gcc-2.95.3/gcc/config/rs6000/xm-macosx.h	2003-12-02 17:50:55.000000000 +0100
@@ -0,0 +1,3 @@
+#include "rs6000/xm-rs6000.h"
+
+#undef USG
